#include <stdio.h>
#include "bldc.h"

static volatile short zero_count = 0;

static void __attribute__((interrupt))
encz_handler ()
{
  zero_count = MTU7.TCNT;
}

main()
{
  int i;
  int old_halls = -1;
  int old_zcount = -1;
  int old_count = -1;
  int old_tgrc = -1;
  int enca, encb;

  bldc_init ();

  tty_puts("Hello from Encoder 1!\n");
  tty_puts("Simple encoder test\n");

  /* Shut off the motor.  */
  PORTB.DR.BYTE = UL | VL | WL;

  MTU7.TGRA = 0x8000;
  MTU7.TMDR.BIT.MD = 4; /* phase counting mode 1 */
#if 0
  MTU7.TIOR.BIT.IOA = 8; /* Table 17.24: Input capture CNT->GRA on MTIOC7A */
#endif
  MTUB.TSTR.BIT.CST1 = 1; /* start MTU7 */

  MTU7.TCR.BIT.CCLR = 2; /* TGRB match clears */
  MTU7.TGRB = 4000;

  MTU6.TMDR.BIT.MD = 0;	/* normal mode */
  MTU6.TMDR.BIT.BFA = 1; /* TGRA->TGRC buffered */
  MTU6.TCR.BIT.TPSC = 1; /* PCLK/4 */
#define SPEED_CLK (48000000/4)
  MTU6.TCR.BIT.CCLR = 1; /* Table 17.6: clear on TGRA capture */
  MTU6.TIORH.BIT.IOA = 12; /* Table 17.22: TGRA input capture on MTU7 clock */
  MTUB.TSTR.BIT.CST0 = 1; /* start MTU6 */

#if 0
  _vectors[VECT(ICU,IRQ7)] = encz_handler;
  ICU.IRQCR[7].BIT.IRQMD = 3;
  IPR(ICU,IRQ7) = 5;
  IEN(ICU,IRQ7) = 1;
#endif

  printf("Looping...\n");
  while (1)
    {
      //int halls = PORTA.PORT.BYTE & 7;

      short count = MTU7.TCNT;
      int tgrc = MTU6.TGRC;
      int pos;
      int deg;
      short tgra = (short)(MTU7.TGRA);


      enca = ENC_A ? 1 : 0;
      encb = ENC_B ? 1 : 0;

      PORT7.DR.BIT.B4 = enca;
      PORT7.DR.BIT.B5 = encb;

#if 0
      pos = count - tgra;
      if (pos < 0)
	pos += 4000;
      if ((unsigned)pos  > 4010)
	{
	  static int old_count = -1;
	  if (count != old_count)
	    {
	      old_count = count;
	      printf("no sync  \r");
	      fflush (stdout);
	    }
	  continue;
	}
      deg = pos * 360 / 4000;
#endif


#if 0
      if (count != old_count)
	{
	  old_count = count;
	  printf("Count: %04x\r", count);
	  fflush (stdout);
	}

      if (zero_count != old_zcount)
	{
	  printf("\nZCount: %04x diff %d\n", zero_count, zero_count - old_zcount);
	  old_zcount = zero_count;
	  fflush (stdout);
	}
#endif

      if (tgrc != old_tgrc)
	{
	  /* tgrc is ticks per enc quad-phase */
	  /* (tgrc*4000) is ticks per rot */
	  /* SPEED_CLK is ticks per sec */
	  /* spd/(tgrc*4000) is thus rot/sec */
	  int rpm = SPEED_CLK * 60 / (tgrc * 4000);
	  printf("TGRC: %04x %7d   POS %04x  \r", tgrc, rpm, count & 0xffff);
	  old_tgrc = tgrc;
	  fflush (stdout);
	}
    }

  exit (0);
}
