#include <stdio.h>
#include "bldc.h"

extern int rotations;

main()
{
  int i;
  int old_pos = -1;
  int enca, encb;

  bldc_init ();
  encoder_init ();

  tty_puts("Hello from Encoder 1!\n");
  tty_puts("Simple encoder test\n");

  printf("waiting for encoder sync\n");
  while (!encoder_synced ())
    ;

  printf("Looping...\n");
  while (1)
    {
      int halls = PORTB.PORT.BYTE;

      int pos = encoder_val ();
      int deg = encoder_ang ();
      int rpm = encoder_rpm ();

      enca = ENC_A ? 1 : 0;
      encb = ENC_B ? 1 : 0;

      PORT7.DR.BIT.B4 = enca;
      PORT7.DR.BIT.B5 = encb;

      if (deg != old_pos)
	{
	  /* tgrc is ticks per enc quad-phase */
	  /* (tgrc*4000) is ticks per rot */
	  /* SPEED_CLK is ticks per sec */
	  /* spd/(tgrc*4000) is thus rot/sec */
	  printf("RPM %7d   POS %4d  ANG %3d  ABS %16llx", rpm, pos, deg, encoder_lval());
	  printf("%s %s %s  ",
		 halls & U_HALL ? "\033[31mU\033[0m" : "-",
		 halls & V_HALL ? "\033[32mV\033[0m" : "-",
		 halls & W_HALL ? "\033[34mW\033[0m" : "-");
	  printf("\r");
	  old_pos = deg;
	  fflush (stdout);
	}
    }

  exit (0);
}
