#include <stdio.h>
#include <math.h>
#include "bldc.h"

extern int cpwm_step;

double
dcos (double pos)
{
  return cos (pos * M_PI / 90);
}

#define MINWAIT 300

main()
{
  int i;
  int halls, old_halls = -1;
  int u = 0;
  int v = 0;
  int w = 0;
  int power = 0;
  int pos, old_pos = -999;
  int running = 0;
  int update_status = 1;
  int then = 0;
  int direction = 1;
  int hall;

  bldc_init ();

  tty_puts("\033[1;1H\033[2J\n\nHello from Sine 2!\n");

  /* Shut off the motor.  */
  PORTB.DR.BYTE = UL | VL | WL;

  printf("Looping...\n");
  rx_enable();

  while (1)
    {

      if (tty_ready ())
	{
	  int c = tty_getc ();
	  switch (c)
	    {
	    case 's':
	    case ' ':
	      motor_stop ();
	      power = 0;
	      running = 0;
	      RED = BLUE = GREEN = 0;
	      break;

	    case '0' ... '9':
	      running = 1;
	      power = (c - '0');
	      motor_rpm (power * direction * 60);
	      break;

	    case '-':
	    case '_':
	      direction = -1;
	      motor_rpm (power * direction * 60);
	      break;

	    case '+':
	    case '=':
	      direction = 1;
	      motor_rpm (power * direction * 60);
	      break;
	    }
	}

      if (tty_idle () && (msec - then) > MINWAIT)
	{
	  int rpm = encoder_rpm ();
	  int ang = encoder_ang ();
	  int lpos = encoder_lval ();
	  then = msec;
	  update_status = 0;
	  printf("\033[1;1H  pos = %5d, ang = %5d, lpos = %d, \033[%dmpower = %5d\033[0m,  RPM = %5d  step %3d ",
		 pos, ang, lpos, running ? 32 : 31, power*direction, rpm, cpwm_step);

#if 1
	  temperature();
	  printf(" VMotor = %5.1f, %5.3f ", motor_volts (), motor_current);
#endif

	  printf("\033[K\n");
	  printf("%04x %04x %04x  \n", MTU3.TGRD, MTU4.TGRC, MTU4.TGRD);

	  motor_status ();
	  fflush (stdout);
	}
    }

  exit (0);
}
